#!/bin/sh 
# \
exec $WISH $0 $@
package require Debug

namespace eval Laola {
    set laola_id \xd0\xcf\x11\xe0\xa1\xb1\x1a\xe1
    #set header_start [binary format a8i4s3c2i4 $loala_id "0 0 0 0" \
        "59 3 -2" \x09 \x00 "6 0 0"]

}

proc Laola::fillBlock { block } {
   set missing [expr 0x200-[string length $block]]
    if { $missing < 0 } {
        Debug::printMessage error "Laola Block too large."
    } else {
        append block [string repeat \xff $missing]
    }
    #puts [string length $block]
    return $block
}

proc Laola::getHeaderBlock { num_of_bbd_blocks 
                             root_startblock 
                             sbd_startblock
                             bbd_list } {
    variable laola_id
    set header [binary format a8i4s3a2i* $laola_id "0 0 0 0" "59 3 -2" \
                    \x09\x00 [concat [list 6 0 0 $num_of_bbd_blocks \
                                      $root_startblock \
                                          0 1000 $sbd_startblock 1 -2 0] \
                                  $bbd_list]]
 
    return [fillBlock $header]
}

proc Laola::getBigBlockDepot { blocklist } {
    return [fillBlock [binary format i* $blocklist]]
}

proc Laola::getPropertyStorageBlock { name type prev next dir start size } {
    switch $type {
        root { set tnr 5 }
        storage { set tnr 1 }
        stream { set tnr 2 }
        default { set tnr $type }
    }
    set timestamp1 "0 0"
    # todo: calculate the timestamp2 from current time
    set timestamp2 "0 0" ;#"536226182 29054893"
    set nname ""
    foreach char [split $name ""] {
        append nname $char\x00
    }
    append nname [string repeat \x00 [expr 0x40-[string length $nname]]]
    puts "$name,[string length $nname],[string length $name]"
    return [binary format a64scciiia4iia4ii2i2iii $nname \
                [expr [string length $name]*2+2] \
                $tnr 1 $prev $next $dir \x00\x09\x02\x00 0 192 \
                \x00\x00\x00\x46 0 $timestamp1 $timestamp2 $start $size 0]
    
}
    

##proc Laola::open { filename mode } {
#    if { $mode == "w" } {
#    }
#}

proc Laola::test { filename } {
    set bifffile biff2a.xls
    set fd [open $filename w]
    set blocks [expr (2*[file size $bifffile])/0x200+1]
    if { $blocks < 8 } {
        set blocks 8
    }
    puts blocks=$blocks
    puts -nonewline $fd [getHeaderBlock 1 [expr $blocks+1] -2 $blocks]
    #puts [string length [getBigBlockDepot {-3 1 -2 -2}]]
    set bifffd [open $bifffile]
    set blist {}
    set limit -1
    set buffer [read $bifffd [file size $bifffile]]
    #set buffer $buffer$buffer
    for { set i 0 } { $i < $blocks } { incr i } {
        set block [string range $buffer [expr $i*512] [expr ($i+1)*512-1]]
        if { [string length $block] != 512 } {
            set block [fillBlock $block]
        }
        puts -nonewline $fd $block
        lappend blist [expr $i]
    }
    lappend blist -2
    close $bifffd
    #puts -nonewline $fd [getBigBlockDepot {-2}]
    #puts -nonewline $fd [getBigBlockDepot {-1}]
    puts -nonewline $fd [getBigBlockDepot  "$blist -2"]
    #puts $fd [getBigBlockDepot {-3 1 -2}]
    puts -nonewline $fd [getPropertyStorageBlock "Root Entry" root -1 -1 1 -2 0]
    puts -nonewline $fd [getPropertyStorageBlock "Book" stream -1 -1 -1 0 [expr $blocks*0x200]]
    puts -nonewline $fd [getPropertyStorageBlock "" stream -1 -1 -1 0 0]
    puts -nonewline $fd [getPropertyStorageBlock "" stream -1 -1 -1 0 0]
    
    puts -nonewline $fd [getPropertyStorageBlock "" storage -1 -1 -1 -1 0]
    puts -nonewline $fd [getPropertyStorageBlock "" storage -1 -1 -1 -1 0]
    ##puts $fd [getBigBlockDepot {-1}]

    #puts $fd [getBigBlockDepot {-1}]
    #puts $fd [getBigBlockDepot {-1}]
    close $fd
}

Laola::test laola.xls
exit

# strings float ints